
require 'helpers/configuration'
module HousingMisc
  extend Configuration

  define_setting :aws_access_token
  define_setting :aws_access_secret
  define_setting :region
  define_setting :bucket
  define_setting :origin
  define_setting :credentials_flag
  define_setting :expose_headers
  define_setting :max_age
  define_setting :sidekiq_custom_threshold, {}
  define_setting :sidekiq_message_url, "https://hooks.slack.com/services/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"
  define_setting :app_name


  require 'housing_misc/api_helper'
  require 'housing_misc/engine'
  require 'housing_misc/slice_helper'
  require 'housing_misc/json_slice_render'
  require 'housing_misc/boolean_evaluator'
  require 'housing_misc/railtie'
  require 'housing_misc/distance_unit'
  require 'housing_misc/models_reflections_helper'
  require 'housing_misc/aerospike_cache_extension'
  require 'housing_misc/encrypt_decrypt'
  require 'housing_misc/net_http_generic_request'
  require 'housing_misc/diff_checker'
end
